<template>
  <v-row justify="center" align="center">
    <v-progress-linear
        v-if="loading"
        indeterminate
        color="yellow darken-2"
        fixed
        top
        style="z-index: 5;"
    ></v-progress-linear>
    <v-col cols="12" sm="8" md="8">
      <div class="text-center">
        <logo />
      </div>
      <v-card>
        <v-card-title class="headline">
          Welcome to the Vuetify + Nuxt.js
        </v-card-title>
        <v-card-text>
        <v-btn block @click="getData">Обновить посты</v-btn>
        <div v-if="posts && posts.length">
          <v-list two-lines>
            <v-list-item tag="li" v-for="item in posts" class="my-2" style="background: #666; cursor: pointer" :to="{ name: 'post', params: { post: item.id }}">
              <v-list-item-content>
                <v-list-item-title>Заголовок: {{ item.title }}</v-list-item-title>
                <v-list-item-subtitle>Описание: {{ item.description }}</v-list-item-subtitle>
              </v-list-item-content>
            </v-list-item>
          </v-list>
        </div>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-pagination
              v-model="page"
              :length="last_page"
          ></v-pagination>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>

import axios from 'axios'
import Logo from '~/components/Logo.vue'

export default {
  async asyncData({ params }) {
    let response = await axios.get('https://api.grtsk-cmp.studio-luck.ru/api/common/tasks/', {
      params: {
        page: 1
      },
      headers: {
        "Content-Type": "application/json",
        "Accept": "application/json",
        "Authorization": "Bearer skGNiohg3Ohbnlmwdtw73IbkOIf4zUA7HKazKRJ4qWnSNb0dT2PqTrnHxAgS",
      }
    })

    return {
      posts: response.data.data,
      page: response.data.current_page,
      last_page: response.data.last_page,
    }
  },
  data() {
    return {
      posts: [],
      error: null,
      loading: false
    }
  },
  components: {
    Logo
  },
  methods: {
    getData() {
      this.loading = true
      axios.get('https://api.grtsk-cmp.studio-luck.ru/api/common/tasks', {
        params: {
          page: this.page
        },
        headers: {
          "Content-Type": "application/json",
          "Accept": "application/json",
          "Authorization": "Bearer skGNiohg3Ohbnlmwdtw73IbkOIf4zUA7HKazKRJ4qWnSNb0dT2PqTrnHxAgS",
        }
      }).then(response => {
        this.posts = response.data.data
        this.loading = false
      }, error => {
        this.error = error
        this.loading = false
      })
    }
  },
  watch: {
    page: function () {
      this.getData()
    }
  }
}
</script>
